## mercator 1501882437.e7407ea

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.2)

project(Mercator)
set(CMAKE_CXX_STANDARD 14)
include(GNUInstallDirs)
include(FindPkgConfig)

# Version setup

set(MERCATOR_VERSION_MAJOR 0)
set(MERCATOR_VERSION_MINOR 4)
set(MERCATOR_VERSION_PATCH 0)

set(VERSION ${MERCATOR_VERSION_MAJOR}.${MERCATOR_VERSION_MINOR}.${MERCATOR_VERSION_PATCH})
set(SUFFIX -${MERCATOR_VERSION_MAJOR}.${MERCATOR_VERSION_MINOR})

set(MERCATOR_ABI_CURRENT 0)
set(MERCATOR_ABI_REVISION 0)
set(MERCATOR_ABI_AGE 0)
math(EXPR MERCATOR_SOVERSION ${MERCATOR_ABI_CURRENT}-${MERCATOR_ABI_AGE})
set(MERCATOR_ABI_VERSION ${MERCATOR_SOVERSION}.${MERCATOR_ABI_AGE}.${MERCATOR_ABI_REVISION})

# Set compiler flags
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall")

include_directories("${PROJECT_SOURCE_DIR}")

# Meta data

string(TOLOWER "${PROJECT_NAME}" PROJECT_NAME_LOWER)
set(DESCRIPTION "A config handling library for the Worldforge system.")

# Check for libraries
pkg_check_modules(WF REQUIRED wfmath-1.0>=1.0.0)

link_directories(${WF_LIBRARY_DIRS})
include_directories(${WF_INCLUDE_DIRS})
# Populate for pkg-config
set(REQUIRES "wfmath-1.0")

# Define source files for libraries

set(SOURCE_FILES
        Mercator/Area.cpp
        Mercator/AreaShader.cpp
        Mercator/BasePoint.cpp
        Mercator/Buffer.cpp
        Mercator/DepthShader.cpp
        Mercator/Effector.cpp
        Mercator/FillShader.cpp
        Mercator/Forest.cpp
        Mercator/GrassShader.cpp
        Mercator/HeightMap.cpp
        Mercator/Intersect.cpp
        Mercator/Matrix.cpp
        Mercator/Mercator.cpp
        Mercator/Plant.cpp
        Mercator/Segment.cpp
        Mercator/Shader.cpp
        Mercator/ShaderFactory.cpp
        Mercator/Surface.cpp
        Mercator/Terrain.cpp
        Mercator/TerrainMod.cpp
        Mercator/ThresholdShader.cpp
        Mercator/TileShader.cpp)

set(HEADER_FILES
        Mercator/Area.h
        Mercator/AreaShader.h
        Mercator/BasePoint.h
        Mercator/Buffer.h
        Mercator/DepthShader.h
        Mercator/Effector.h
        Mercator/FillShader.h
        Mercator/Forest.h
        Mercator/GrassShader.h
        Mercator/HeightMap.h
        Mercator/Intersect.h
        Mercator/iround.h
        Mercator/Matrix.h
        Mercator/Mercator.h
        Mercator/Plant.h
        Mercator/RandCache.h
        Mercator/Segment.h
        Mercator/Shader.h
        Mercator/ShaderFactory.h
        Mercator/ShaderFactory_impl.h
        Mercator/Surface.h
        Mercator/Terrain.h
        Mercator/TerrainMod.h
        Mercator/TerrainMod_impl.h
        Mercator/ThresholdShader.h
        Mercator/TileShader.h)


# This macro defines a library
macro(wf_add_library _LIB_NAME _SOURCE_FILES_VAR _HEADER_FILES_VAR)

    add_library(${_LIB_NAME} SHARED ${${_SOURCE_FILES_VAR}})
    set_target_properties(${_LIB_NAME} PROPERTIES
            VERSION ${MERCATOR_ABI_VERSION}
            SOVERSION ${MERCATOR_SOVERSION}
            )

    install(TARGETS ${_LIB_NAME}
            LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR})

    foreach (file ${${_HEADER_FILES_VAR}})
        get_filename_component(dir ${file} DIRECTORY)
        install(FILES ${file} DESTINATION include/${PROJECT_NAME}${SUFFIX}/${dir})
    endforeach ()

    set(PKG_CONFIG_LIBS "-l${_LIB_NAME} ${PKG_CONFIG_LIBS}")

    target_link_libraries(${_LIB_NAME} ${WF_LIBRARIES})

endmacro()

wf_add_library(mercator${SUFFIX} SOURCE_FILES HEADER_FILES)


# pkg-config files
configure_file(${PROJECT_NAME_LOWER}.pc.in ${PROJECT_NAME_LOWER}${SUFFIX}.pc @ONLY)
install(FILES ${PROJECT_BINARY_DIR}/${PROJECT_NAME_LOWER}${SUFFIX}.pc DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)

# RPM spec files
#TODO: fix these
configure_file(${PROJECT_NAME_LOWER}.spec.in ${PROJECT_NAME_LOWER}.spec @ONLY)
#TODO: fix these
configure_file(mingw32-${PROJECT_NAME_LOWER}.spec.in mingw32-${PROJECT_NAME_LOWER}.spec @ONLY)

# Add test
enable_testing()

# Add a "check" target, which builds and runs the tests.
add_custom_target(check COMMAND ${CMAKE_CTEST_COMMAND})

#Macro for adding a test. The test name will be extracted from the name of the first submitted file.
#Additional files can be submitted as varargs.
macro(wf_add_test TEST_FILE)

    get_filename_component(TEST_NAME ${TEST_FILE} NAME_WE)

    add_executable(${TEST_NAME} EXCLUDE_FROM_ALL ${TEST_FILE} ${ARGN})
    target_link_libraries(${TEST_NAME} ${PROJECT_NAME_LOWER}${SUFFIX})
    add_test(NAME ${TEST_NAME} COMMAND ${TEST_NAME})

    add_dependencies(check ${TEST_NAME})
endmacro()


wf_add_test(tests/main.cpp)
wf_add_test(tests/Terraintest.cpp)
wf_add_test(tests/Shadertest.cpp)
wf_add_test(tests/TerrainModtest.cpp)
wf_add_test(tests/Intersecttest.cpp)
wf_add_test(tests/testPhys.cpp)
wf_add_test(tests/timeSeg.cpp tests/util_timer.cpp tests/util_timer.h)
wf_add_test(tests/Planttest.cpp)
wf_add_test(tests/Foresttest.cpp)
wf_add_test(tests/testQRNG.cpp)
wf_add_test(tests/Areatest.cpp)
wf_add_test(tests/TileShadertest.cpp)
wf_add_test(tests/ShaderFactorytest.cpp)
wf_add_test(tests/testWFMath.cpp)
wf_add_test(tests/Buffertest.cpp)
wf_add_test(tests/Segmenttest.cpp)
wf_add_test(tests/AreaShadertest.cpp)
wf_add_test(tests/BasePointtest.cpp)
wf_add_test(tests/DepthShadertest.cpp)
wf_add_test(tests/FillShadertest.cpp)
wf_add_test(tests/GrassShadertest.cpp)
wf_add_test(tests/ThresholdShadertest.cpp)
wf_add_test(tests/Matrixtest.cpp)
wf_add_test(tests/TerrainaddAreatest.cpp)
wf_add_test(tests/Segmentperf.cpp)

# Doxygen support, exports a "docs" target.

find_package(Doxygen)
set(DOXYGEN_INPUT Mercator)
configure_file(Doxyfile.in Doxyfile @ONLY)

if (DOXYGEN_FOUND)

    set(DOXYGEN_INPUT ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile)
    set(DOXYGEN_OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/doc)

    add_custom_command(
            OUTPUT ${DOXYGEN_OUTPUT}
            COMMAND ${CMAKE_COMMAND} -E echo_append "Building API Documentation..."
            COMMAND ${DOXYGEN_EXECUTABLE} ${DOXYGEN_INPUT}
            COMMAND ${CMAKE_COMMAND} -E echo "Done."
            WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
            DEPENDS ${DOXYGEN_INPUT}
    )

    add_custom_target(docs DEPENDS ${DOXYGEN_OUTPUT})

endif (DOXYGEN_FOUND)

add_custom_command(
        OUTPUT ChangeLog
        COMMAND ${CMAKE_SOURCE_DIR}/support/generate-ChangeLog.sh ${CMAKE_SOURCE_DIR} ${CMAKE_SOURCE_DIR} 8bd480b053190ffde2afe33af66f484953036f5a
)
add_custom_target(changelog DEPENDS ChangeLog)


# Packaging (for source tarballs

set(CPACK_PACKAGE_DESCRIPTION_SUMMARY ${DESCRIPTION})
set(CPACK_PACKAGE_VENDOR "Worldforge")
set(CPACK_PACKAGE_DESCRIPTION_FILE "${PROJECT_SOURCE_DIR}/README.md")
set(CPACK_RESOURCE_FILE_LICENSE "${PROJECT_SOURCE_DIR}/COPYING")
set(CPACK_PACKAGE_VERSION_MAJOR "${MERCATOR_VERSION_MAJOR}")
set(CPACK_PACKAGE_VERSION_MINOR "${MERCATOR_VERSION_MINOR}")
set(CPACK_PACKAGE_VERSION_PATCH "${MERCATOR_VERSION_PATCH}")
#set(CPACK_INSTALL_SCRIPT "sh ${CMAKE_SOURCE_DIR}/support/generate-ChangeLog.sh ${CMAKE_SOURCE_DIR} ${CPACK_PACKAGE_INSTALL_DIRECTORY} 8bd480b053190ffde2afe33af66f484953036f5a")

set(CPACK_SOURCE_GENERATOR TBZ2 ZIP)

set(CPACK_SOURCE_PACKAGE_FILE_NAME "${PROJECT_NAME}-${VERSION}" CACHE INTERNAL "tarball basename")

set(CPACK_SOURCE_IGNORE_FILES
        # no hidden files
        "/\\\\..+$"
        "~$"
        )

include(CPack)

## mercator 0.3.0

=== debian/changelog ===
mercator (0.3.0-2) unstable; urgency=low

  * marked symbols as optional for GCC 4.7 (closes: #667274)

 -- Stephen M. Webb <stephen.webb@bregmasoft.ca>  Wed, 30 May 2012 09:40:42 -0400

mercator (0.3.0-1) unstable; urgency=low

  * new upstream release
  * new maintainer: Debian games team (closes: #653975)
    - added myself as uploader
  * changed binary package names for SONAME bump
  * updated to 3.0 (quilt) source format
  * updated Standards-Version to 3.9.3 (no changes required)
  * debian/control: added Vcs- fields
  * added symbols tracking
  * debian/copyright: convert to DEP-5 format
  * converted to use the dh build sequencer
  * changed package compression from gz to xz

 -- Stephen M. Webb <stephen.webb@bregmasoft.ca>  Sun, 26 Feb 2012 11:52:29 -0500

mercator (0.2.7-3) unstable; urgency=low

  * debian/libmercator-0.2-dev.install: Don't install *.la file.
  * debian/control: Remove url from long descriptions.
  * debian/control: Updated Standards-Version to 3.8.3.

 -- Michael Koch <konqueror@gmx.de>  Thu, 27 Aug 2009 08:26:35 +0200

mercator (0.2.7-2) unstable; urgency=low

  * Upload to unstable.

 -- Michael Koch <konqueror@gmx.de>  Sat, 25 Jul 2009 20:17:06 +0200

mercator (0.2.7-1) experimental; urgency=low

  * New upstream release.
    - introduces new SONAME
  * debian/copyright: clarify license.
  * debian/control: Updated Standards-Version to 3.8.2.
  * debian/control: Move libmercator-0.2-5-dbg to debug section.
  * debian/control: Add Depends: ${misc:Depends} to all packages.
  * debian/control: Build-Depend on debelper >= 5.

 -- Michael Koch <konqueror@gmx.de>  Tue, 21 Jul 2009 14:27:53 +0200

mercator (0.2.6-1) experimental; urgency=low

  * New upstream release
    - Removed debian/patches/mercator-gcc43.patch. Obsoleted.
    - Renamed library package to match soname.
  * Upload to experimental.
  * Added debug package.
  * Reworked debian/copyright.
  * Increased Debhelper level to 5 for easy -dbg package builds.
  * Build-Depend on chrpath and remove rpath from library.
  * Updated Standards-Version to 3.8.0.
  * Updated watch file to use uscan sourceforge mapper.

 -- Michael Koch <konqueror@gmx.de>  Wed, 20 Aug 2008 13:53:38 +0200

mercator (0.2.5-3) unstable; urgency=low

  * Added debian/patches/mercator-gcc43.patch to fix GCC 4.3 errors.
    Closes: #461963

 -- Michael Koch <konqueror@gmx.de>  Mon, 21 Jan 2008 22:40:50 +0100

mercator (0.2.5-2) unstable; urgency=low

  * Replaced ${Source-Version} in debian/control.
  * Addded Build-Depends on autotools-dev to ensure update of config.guess and
    config.sub at build-time.
  * Updated Standard-Version to 3.7.3.
  * Added Homepage field to debian/control.

 -- Michael Koch <konqueror@gmx.de>  Mon, 24 Dec 2007 08:59:43 +0100

mercator (0.2.5-1) unstable; urgency=low

  * New upstream release.
  * Build-Depends on debhelper(>= 4.1.0) and libwfmath-0.3-dev (>= 0.3.5).
  * Updated Standards-Version to 3.7.2

 -- Michael Koch <konqueror@gmx.de>  Sun, 10 Sep 2006 16:12:17 +0000

mercator (0.2.4-3) unstable; urgency=low

  * Did the C++ ABI transition (Closes: #339231).

 -- Michael Koch <konqueror@gmx.de>  Tue, 20 Dec 2005 07:55:18 +0000

mercator (0.2.4-2) unstable; urgency=low

  * Make sure to include all header files in the dev package
  * Upload sponsored by Petter Reinholdtsen

 -- Michael Koch <konqueror@gmx.de>  Sun,  9 Oct 2005 13:19:46 +0000

mercator (0.2.4-1) unstable; urgency=low

  * New upstream release
  * Updated watch file to update to new release more easily
  * Moved libmercator-0.2-dev from section devel to section libdevel

 -- Michael Koch <konqueror@gmx.de>  Sun,  2 Oct 2005 12:27:55 +0000

mercator (0.2.3-1) unstable; urgency=low

  * New upstream release
  * Reworked package descriptions
  * Added debian/watch
  * Updated Standards-Version to 3.6.2
  * Updated address of FSF in debian/copyright
  * Upload sponsored by Petter Reinholdtsen

 -- Michael Koch <konqueror@gmx.de>  Mon,  5 Sep 2005 05:43:21 +0000

mercator (0.2.1-1) unstable; urgency=low

  * New upstream release
  * Removed debian/patches/gcc-3.4.patch. Now fixed upstream.
  * Updated SONAME
  * Updated Build-Depend to depend on libwfmath-0.3-dev (>= 0.3.2)
  * debian/rules: Added check-install target

 -- Michael Koch <konqueror@gmx.de>  Tue, 27 Jul 2004 13:49:02 +0200

mercator (0.2.0-4) unstable; urgency=low

  * Added patch for GCC 3.4.
    Thanks to Andreas Jochens <aj@andaco.de>
    (Closes: #260576)

 -- Michael Koch <konqueror@gmx.de>  Wed, 21 Jul 2004 11:50:18 +0200

mercator (0.2.0-3) unstable; urgency=low

  * libmercator-0.2-dev: Fixed typo in Depends line (Closed: #257789).

 -- Michael Koch <konqueror@gmx.de>  Tue,  6 Jul 2004 12:34:18 +0200

mercator (0.2.0-2) unstable; urgency=low

  * Use CDBS as build system now.
  * Fixed creating of shlibs file.

 -- Michael Koch <konqueror@gmx.de>  Sun,  4 Jul 2004 16:24:24 +0200

mercator (0.2.0-1) unstable; urgency=low

  * Initial Release (Closes: #249594)

 -- Michael Koch <konqueror@gmx.de>  Fri, 21 May 2004 12:02:33 +0200

=== debian/control ===
Source: mercator
Section: libs
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders: Stephen M. Webb <stephen.webb@bregmasoft.ca>
Build-Depends: dh-autoreconf,
               debhelper (>= 9),
               libwfmath-0.3-dev (>= 0.3.11),
               pkg-config
Standards-Version: 3.9.3
Homepage: http://www.worldforge.org/
Vcs-Git: git://git.debian.org/git/pkg-games/mercator.git
Vcs-Browser: http://git.debian.org/?p=pkg-games/mercator.git

Package: libmercator-0.3-1
Architecture: any
Multi-Arch: same
Pre-Depends: dpkg (>= 1.15.6~), ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: WorldForge terrain library
 Mercator is primarily aimed at terrain for multiplayer online games and
 forms one of the WorldForge core libraries.
 It is intended to be used as a terrain library on the client, while a
 subset of features are useful on the server.
 .
 Mercator is designed in such a way that individual tiles can be
 generated on-the-fly from a very small source data set.  Each tile uses
 a fast deterministic random number generation to ensure that identical
 results are produced "anytime, anywhere".  This enables transmission of
 terrain across low bandwidth links as part of the standard data stream,
 or server side collision detection with the same terrain that the
 player sees.
 .
 The use of tiles means that there is inherently a large degree of gross
 control of the shape of the terrain.  Finer control is implemented by
 allowing geometric modifications - for example, a polygonal area might
 be flattened, or a crater could be applied.

Package: libmercator-0.3-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Pre-Depends: dpkg (>= 1.15.6~)
Depends: libmercator-0.3-1 (= ${binary:Version}),
         libwfmath-0.3-dev,
         ${misc:Depends}
Description: WorldForge terrain library - development files
 Mercator is primarily aimed at terrain for multiplayer online games and
 forms one of the WorldForge core libraries.
 It is intended to be used as a terrain library on the client, while a
 subset of features are useful on the server.
 .
 Mercator is designed in such a way that individual tiles can be
 generated on-the-fly from a very small source data set.  Each tile uses
 a fast deterministic random number generation to ensure that identical
 results are produced "anytime, anywhere".  This enables transmission of
 terrain across low bandwidth links as part of the standard data stream,
 or server side collision detection with the same terrain that the
 player sees.
 .
 The use of tiles means that there is inherently a large degree of gross
 control of the shape of the terrain.  Finer control is implemented by
 allowing geometric modifications - for example, a polygonal area might
 be flattened, or a crater could be applied.
 .
 This package contains the files for developing with the mercator library.

Package: libmercator-0.3-1-dbg
Section: debug
Priority: extra
Architecture: any
Pre-Depends: dpkg (>= 1.15.6~)
Depends: libmercator-0.3-1 (= ${binary:Version}), ${misc:Depends}
Description: WorldForge terrain library - debugging symbols
 Mercator is primarily aimed at terrain for multiplayer online games and
 forms one of the WorldForge (http://www.worldforge.org) core libraries.
 It is intended to be used as a terrain library on the client, while a
 subset of features are useful on the server.
 .
 Mercator is designed in such a way that individual tiles can be
 generated on-the-fly from a very small source data set.  Each tile uses
 a fast deterministic random number generation to ensure that identical
 results are produced "anytime, anywhere".  This enables transmission of
 terrain across low bandwidth links as part of the standard data stream,
 or server side collision detection with the same terrain that the
 player sees.
 .
 The use of tiles means that there is inherently a large degree of gross
 control of the shape of the terrain.  Finer control is implemented by
 allowing geometric modifications - for example, a polygonal area might
 be flattened, or a crater could be applied.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --with autoreconf

override_dh_install:
	dh_install --fail-missing -X.la -X.a

override_dh_strip:
	set -e; \
	for pkg in $(patsubst %-dbg,%,$(filter %-dbg,$(shell dh_listpackages))); do \
		dh_strip -p$${pkg} --dbg-package=$${pkg}-dbg; \
	done
	dh_strip -s --remaining-packages

override_dh_builddeb:
	dh_builddeb -- -Zxz

=== debian/watch ===
version=3
http://sf.net/worldforge/mercator-(.*)\.tar\.bz2 debian uupdate

## mercator 0.3.2

=== debian/changelog ===
mercator (0.3.2-2) unstable; urgency=medium

  * Team upload.
  * Import changes from Ubuntu for g++-5 ABI transition, fixing FTBFS
    (Closes: #778002) and renaming library for new ABI (Closes: #791201).
    Thanks to Steve Langasek.
    - Build-depend on the transitioned wfmath package so that things
      happen in the right order.

 -- Simon McVittie <smcv@debian.org>  Tue, 18 Aug 2015 23:25:53 +0100

mercator (0.3.2-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Fixing symbol file (Closes: #713344)
  * Libwfmath-1.0 is in the archive, so B-D on it is fine now (Closes: #734961)

 -- Tobias Frost <tobi@debian.org>  Fri, 15 Aug 2014 18:10:38 +0000

mercator (0.3.2-1) unstable; urgency=low

  * new upstream release
  * bumped package names for new SONAME
  * debian/libmercator-0.3-3.symbols: adjusted for ABI changes
  * debian/control: updated Standards-Version to 3.9.4 (updated VCS-* fields)
  * debian/control (libmercator-0.3-3-dbg): made Multi-Arch: same
  * debian/rules: forced verbose build
  * debian/control: bumped libwfmath build-dep to 1.0
  * debian/libmercator-0.3-3.symbols: adjusted for GCC 4.8 (closes: #701321)

 -- Stephen M. Webb <stephen.webb@bregmasoft.ca>  Wed, 05 Jun 2013 14:14:03 -0400

=== debian/control ===
--- 
+++ 
@@ -5,18 +5,20 @@
 Uploaders: Stephen M. Webb <stephen.webb@bregmasoft.ca>
 Build-Depends: dh-autoreconf,
                debhelper (>= 9),
-               libwfmath-0.3-dev (>= 0.3.11),
+               libwfmath-1.0-dev (>= 1.0.2+dfsg1-0.4),
                pkg-config
-Standards-Version: 3.9.3
+Standards-Version: 3.9.4
 Homepage: http://www.worldforge.org/
-Vcs-Git: git://git.debian.org/git/pkg-games/mercator.git
-Vcs-Browser: http://git.debian.org/?p=pkg-games/mercator.git
+Vcs-Git: git://anonscm.debian.org/pkg-games/mercator.git
+Vcs-Browser: http://anonscm.debian.org/git/pkg-games/mercator.git
 
-Package: libmercator-0.3-1
+Package: libmercator-0.3-3v5
 Architecture: any
 Multi-Arch: same
 Pre-Depends: dpkg (>= 1.15.6~), ${misc:Pre-Depends}
 Depends: ${misc:Depends}, ${shlibs:Depends}
+Conflicts: libmercator-0.3-3
+Replaces: libmercator-0.3-3
 Description: WorldForge terrain library
  Mercator is primarily aimed at terrain for multiplayer online games and
  forms one of the WorldForge core libraries.
@@ -41,8 +43,8 @@
 Architecture: any
 Multi-Arch: same
 Pre-Depends: dpkg (>= 1.15.6~)
-Depends: libmercator-0.3-1 (= ${binary:Version}),
-         libwfmath-0.3-dev,
+Depends: libmercator-0.3-3v5 (= ${binary:Version}),
+         libwfmath-1.0-dev,
          ${misc:Depends}
 Description: WorldForge terrain library - development files
  Mercator is primarily aimed at terrain for multiplayer online games and
@@ -65,12 +67,15 @@
  .
  This package contains the files for developing with the mercator library.
 
-Package: libmercator-0.3-1-dbg
+Package: libmercator-0.3-3v5-dbg
 Section: debug
 Priority: extra
 Architecture: any
+Multi-Arch: same
 Pre-Depends: dpkg (>= 1.15.6~)
-Depends: libmercator-0.3-1 (= ${binary:Version}), ${misc:Depends}
+Depends: libmercator-0.3-3v5 (= ${binary:Version}), ${misc:Depends}
+Conflicts: libmercator-0.3-3-dbg
+Replaces: libmercator-0.3-3-dbg
 Description: WorldForge terrain library - debugging symbols
  Mercator is primarily aimed at terrain for multiplayer online games and
  forms one of the WorldForge (http://www.worldforge.org) core libraries.

=== debian/rules ===
--- 
+++ 
@@ -2,6 +2,9 @@
 
 %:
 	dh $@ --with autoreconf
+
+override_dh_auto_configure:
+	dh_auto_configure -- --disable-silent-rules
 
 override_dh_install:
 	dh_install --fail-missing -X.la -X.a

## mercator 0.3.3

=== debian/changelog ===
mercator (0.3.3-6) unstable; urgency=high

  * Update debhelper compatibility to 13 (delete d/compat)
  * Update standards to 4.5.0 (no changes)
  * Remove d/symbols due to continued instability (Closes: #957531)

 -- Olek Wojnar <olek@debian.org>  Fri, 31 Jul 2020 21:23:37 -0400

mercator (0.3.3-5) unstable; urgency=medium

  * Update d/control:
    - New uploader email and URLs
    - Standards to 4.2.1 (no changes)
    - Add Rules-Requires-Root declaration
  * Update d/copyright: refresh Debian info
  * Update d/compat to 11:
    - Update d/rules
    - Update d/control
    - Remove redundant trigger
  * Add d/upstream/metadata: for DEP 12 compliance
  * Update d/rules: migration complete, remove dbgsym-migration flag

 -- Olek Wojnar <olekw.dev@gmail.com>  Mon, 08 Oct 2018 00:35:15 -0400

mercator (0.3.3-4) unstable; urgency=medium

  * Fix symbols for armhf builds with GCC 6

 -- Olek Wojnar <olek-dev@wojnar.org>  Tue, 16 Aug 2016 21:33:38 -0400

mercator (0.3.3-3) unstable; urgency=medium

  * Fix symbols on some non-release architectures

 -- Olek Wojnar <olek-dev@wojnar.org>  Mon, 04 Jul 2016 15:11:22 -0400

mercator (0.3.3-2) unstable; urgency=high

  * Add patch to fix C++11 const float compile issues (Closes: #802285)
  * d/rules: Explicitly build using the C++11 standard
  * Add d/triggers file for ldconfig processing
  * Convert to automatic debug package
  * Update d/control
    - Standards-Version to 3.9.8 (no changes)
    - Update Vcs lines for secure URIs
  * Enable all hardening options
  * Update d/copyright
  * Fix 32-bit symbols

 -- Olek Wojnar <olek-dev@wojnar.org>  Sun, 26 Jun 2016 21:12:58 -0400

mercator (0.3.3-1) unstable; urgency=medium

  * New upstream release (prior packaging by Stephen Webb)
  * Incorporate and acknowledge NMU, thanks Tobias Frost
  * Add myself as new uploader
    - Remove Stephen Webb per his request
    - Thanks for all the contributions, Stephen!
  * d/control: remove pre-dependency on dpkg
  * d/rules: enable parallel build
  * d/rules: remove builddeb override since xz is now default
  * d/watch: update file extensions
  * d/control: tweaks and update standards to 3.9.6 (no changes)
  * Bump SO-name

 -- Olek Wojnar <olek-dev@wojnar.org>  Sun, 27 Sep 2015 16:25:46 -0500

=== debian/control ===
Source: mercator
Section: libs
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders: Olek Wojnar <olek@debian.org>,
           Debian Games Team <team+pkg-games@tracker.debian.org>,
Build-Depends: debhelper-compat (= 13),
               libwfmath-1.0-dev (>= 1.0.2+dfsg1-0.4),
               pkg-config,
Standards-Version: 4.5.0
Rules-Requires-Root: no
Homepage: https://www.worldforge.org/
Vcs-Git: https://salsa.debian.org/games-team/mercator.git
Vcs-Browser: https://salsa.debian.org/games-team/mercator

Package: libmercator-0.3-4
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: WorldForge terrain library
 Mercator is primarily aimed at terrain for multiplayer online games and
 forms one of the WorldForge core libraries.
 It is intended to be used as a terrain library on the client, while a
 subset of features are useful on the server.
 .
 Mercator is designed in such a way that individual tiles can be
 generated on-the-fly from a very small source data set.  Each tile uses
 a fast deterministic random number generation to ensure that identical
 results are produced "anytime, anywhere".  This enables transmission of
 terrain across low bandwidth links as part of the standard data stream,
 or server side collision detection with the same terrain that the
 player sees.
 .
 The use of tiles means that there is inherently a large degree of gross
 control of the shape of the terrain.  Finer control is implemented by
 allowing geometric modifications - for example, a polygonal area might
 be flattened, or a crater could be applied.

Package: libmercator-0.3-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libmercator-0.3-4 (= ${binary:Version}),
         libwfmath-1.0-dev (>= 1.0.2+dfsg1-0.4),
         ${misc:Depends}
Description: WorldForge terrain library - development files
 Mercator is primarily aimed at terrain for multiplayer online games and
 forms one of the WorldForge core libraries.
 It is intended to be used as a terrain library on the client, while a
 subset of features are useful on the server.
 .
 Mercator is designed in such a way that individual tiles can be
 generated on-the-fly from a very small source data set.  Each tile uses
 a fast deterministic random number generation to ensure that identical
 results are produced "anytime, anywhere".  This enables transmission of
 terrain across low bandwidth links as part of the standard data stream,
 or server side collision detection with the same terrain that the
 player sees.
 .
 The use of tiles means that there is inherently a large degree of gross
 control of the shape of the terrain.  Finer control is implemented by
 allowing geometric modifications - for example, a polygonal area might
 be flattened, or a crater could be applied.
 .
 This package contains the files for developing with the mercator library.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CXXFLAGS_MAINT_APPEND = -std=c++11

%:
	dh $@

override_dh_missing:
	dh_missing -X.la -X.a

=== debian/watch ===
version=4
http://sf.net/worldforge/mercator-(.*)\.(?:tar\.(?:gz|bz2|xz)) debian uupdate

## mercator 1576614804.0f9428f

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.2)

project(mercator)
set(CMAKE_CXX_STANDARD 14)
set(CMAKE_CXX_STANDARD_REQUIRED on)
include(GNUInstallDirs)
include(FindPkgConfig)
include(CheckIncludeFile)

# Version setup

set(MERCATOR_VERSION_MAJOR 0)
set(MERCATOR_VERSION_MINOR 4)
set(MERCATOR_VERSION_PATCH 0)

set(VERSION ${MERCATOR_VERSION_MAJOR}.${MERCATOR_VERSION_MINOR}.${MERCATOR_VERSION_PATCH})
set(SUFFIX -${MERCATOR_VERSION_MAJOR}.${MERCATOR_VERSION_MINOR})

set(MERCATOR_ABI_CURRENT 0)
set(MERCATOR_ABI_REVISION 0)
set(MERCATOR_ABI_AGE 0)
math(EXPR MERCATOR_SOVERSION ${MERCATOR_ABI_CURRENT}-${MERCATOR_ABI_AGE})
set(MERCATOR_ABI_VERSION ${MERCATOR_SOVERSION}.${MERCATOR_ABI_AGE}.${MERCATOR_ABI_REVISION})

option(BUILD_TESTING "Should tests always be built; otherwise they will be built when the 'check' target is executed." OFF)
option(BUILD_SHARED_LIBS "Build libraries as shared as opposed to static." ON)

# Set compiler flags
if (CMAKE_CXX_COMPILER_ID STREQUAL "MSVC")
    set(WF_WARNING_FLAGS /W3)
    add_definitions(-D_WIN32_WINNT=0x0601) #target Windows 7
else ()
    set(WF_WARNING_FLAGS -Wall -Winit-self -Wcast-qual -Wwrite-strings -Wextra -Wundef -Wmissing-declarations -Wno-unused-parameter -Wshadow -Wno-missing-field-initializers -Wno-long-long)
endif ()

include_directories("${PROJECT_SOURCE_DIR}/src")

# Meta data

string(TOLOWER "${PROJECT_NAME}" PROJECT_NAME_LOWER)
set(DESCRIPTION "A terrain generation library for the Worldforge system.")

set(WF_LIBRARY_DIRS)
set(WF_INCLUDE_DIRS)
set(WF_LIBRARIES)

if (EXISTS "${CMAKE_BINARY_DIR}/conanbuildinfo.cmake")
    MESSAGE("Using Conan for dependency resolution.")
    include(${CMAKE_BINARY_DIR}/conanbuildinfo.cmake)
    conan_basic_setup()
endif ()

find_package(wfmath
        1.0.3
        REQUIRED)
list(APPEND WF_LIBRARIES ${wfmath_LIBRARIES})
list(APPEND WF_INCLUDE_DIRS ${wfmath_INCLUDE_DIR})
list(APPEND WF_LIBRARY_DIRS ${wfmath_LIBRARY_DIR})

link_directories(${WF_LIBRARY_DIRS})
include_directories(${WF_INCLUDE_DIRS})
link_libraries(${WF_LIBRARIES})

# Populate for pkg-config
set(REQUIRES "wfmath-1.0")

# This macro defines a library
macro(wf_add_library _LIB_NAME _SOURCE_FILES_VAR _HEADER_FILES_VAR)

    add_library(${_LIB_NAME} ${${_SOURCE_FILES_VAR}})
    add_library(${_LIB_NAME}_object OBJECT ${${_SOURCE_FILES_VAR}})
    set_target_properties(${_LIB_NAME} PROPERTIES
            VERSION ${MERCATOR_ABI_VERSION}
            SOVERSION ${MERCATOR_SOVERSION}
            )

    install(TARGETS ${_LIB_NAME}
            ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
            LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR})

    foreach (file ${${_HEADER_FILES_VAR}})
        get_filename_component(dir ${file} DIRECTORY)
        install(FILES ${file} DESTINATION include/${PROJECT_NAME}${SUFFIX}/${dir})
    endforeach ()

    target_link_libraries(${_LIB_NAME} ${WF_LIBRARIES})
    target_compile_options(${_LIB_NAME} PRIVATE ${WF_WARNING_FLAGS})

endmacro()

# pkg-config files
configure_file(tools/${PROJECT_NAME_LOWER}.pc.in ${PROJECT_NAME_LOWER}${SUFFIX}.pc @ONLY)
install(FILES ${PROJECT_BINARY_DIR}/${PROJECT_NAME_LOWER}${SUFFIX}.pc DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)

# RPM spec files
#TODO: fix these
configure_file(tools/${PROJECT_NAME_LOWER}.spec.in ${PROJECT_NAME_LOWER}.spec @ONLY)
#TODO: fix these
configure_file(tools/mingw32-${PROJECT_NAME_LOWER}.spec.in mingw32-${PROJECT_NAME_LOWER}.spec @ONLY)

# Add test
enable_testing()

# Add a "check" target, which builds and runs the tests.
add_custom_target(check COMMAND ${CMAKE_CTEST_COMMAND})

#Macro for adding a test. The test name will be extracted from the name of the first submitted file.
#Additional files can be submitted as varargs.
macro(wf_add_test TEST_FILE)

    get_filename_component(TEST_NAME ${TEST_FILE} NAME_WE)

    # If BUILD_TESTING is defined we'll build the test no matter what. This makes it work better on Windows.
    if (BUILD_TESTING)
        add_executable(${TEST_NAME} ${TEST_FILE} ${ARGN} "$<TARGET_OBJECTS:${PROJECT_NAME_LOWER}${SUFFIX}_object>")
    else (BUILD_TESTING)
        add_executable(${TEST_NAME} EXCLUDE_FROM_ALL ${TEST_FILE} ${ARGN} "$<TARGET_OBJECTS:${PROJECT_NAME_LOWER}${SUFFIX}_object>")
    endif (BUILD_TESTING)
    add_test(NAME ${TEST_NAME} COMMAND $<TARGET_FILE:${TEST_NAME}>)

    add_dependencies(check ${TEST_NAME})
endmacro()

add_subdirectory(src)
add_subdirectory(tests)

# Doxygen support, exports a "dox" target.

find_package(Doxygen)
set(DOXYGEN_INPUT src/Mercator)
configure_file(docs/Doxyfile.in Doxyfile @ONLY)

if (DOXYGEN_FOUND)

    set(DOXYGEN_INPUT ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile)
    set(DOXYGEN_OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/docs)

    add_custom_command(
            OUTPUT ${DOXYGEN_OUTPUT}
            COMMAND ${CMAKE_COMMAND} -E echo_append "Building API Documentation..."
            COMMAND ${DOXYGEN_EXECUTABLE} ${DOXYGEN_INPUT}
            COMMAND ${CMAKE_COMMAND} -E echo "Done."
            WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
            DEPENDS ${DOXYGEN_INPUT}
    )

    add_custom_target(dox DEPENDS ${DOXYGEN_OUTPUT})

endif (DOXYGEN_FOUND)

add_custom_command(
        OUTPUT ChangeLog
        COMMAND ${CMAKE_SOURCE_DIR}/support/generate-ChangeLog.sh ${CMAKE_SOURCE_DIR} ${CMAKE_SOURCE_DIR} 8bd480b053190ffde2afe33af66f484953036f5a
)
add_custom_target(changelog DEPENDS ChangeLog)


# CMake config files
include(CMakePackageConfigHelpers)

configure_package_config_file(tools/Config.cmake.in ${PROJECT_BINARY_DIR}/cmake/${PROJECT_NAME}Config.cmake
        INSTALL_DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}
        PATH_VARS CMAKE_INSTALL_INCLUDEDIR CMAKE_INSTALL_LIBDIR)
write_basic_package_version_file(
        ${PROJECT_BINARY_DIR}/cmake/${PROJECT_NAME}ConfigVersion.cmake
        VERSION ${VERSION}
        COMPATIBILITY ExactVersion)
install(FILES
        ${PROJECT_BINARY_DIR}/cmake/${PROJECT_NAME}Config.cmake
        ${PROJECT_BINARY_DIR}/cmake/${PROJECT_NAME}ConfigVersion.cmake
        DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME})


# Packaging (for source tarballs

set(CPACK_PACKAGE_DESCRIPTION_SUMMARY ${DESCRIPTION})
set(CPACK_PACKAGE_VENDOR "Worldforge")
set(CPACK_PACKAGE_DESCRIPTION_FILE "${PROJECT_SOURCE_DIR}/README.md")
set(CPACK_RESOURCE_FILE_LICENSE "${PROJECT_SOURCE_DIR}/COPYING")
set(CPACK_PACKAGE_VERSION_MAJOR "${MERCATOR_VERSION_MAJOR}")
set(CPACK_PACKAGE_VERSION_MINOR "${MERCATOR_VERSION_MINOR}")
set(CPACK_PACKAGE_VERSION_PATCH "${MERCATOR_VERSION_PATCH}")
#set(CPACK_INSTALL_SCRIPT "sh ${CMAKE_SOURCE_DIR}/support/generate-ChangeLog.sh ${CMAKE_SOURCE_DIR} ${CPACK_PACKAGE_INSTALL_DIRECTORY} 8bd480b053190ffde2afe33af66f484953036f5a")

set(CPACK_SOURCE_GENERATOR TBZ2 ZIP)

set(CPACK_SOURCE_PACKAGE_FILE_NAME "${PROJECT_NAME}-${VERSION}" CACHE INTERNAL "tarball basename")

set(CPACK_SOURCE_IGNORE_FILES
        # no hidden files
        "/\\\\..+$"
        "~$"
        )

include(CPack)

=== src/CMakeLists.txt ===
set(SOURCE_FILES
        Mercator/Area.cpp
        Mercator/AreaShader.cpp
        Mercator/BasePoint.cpp
        Mercator/Buffer.cpp
        Mercator/Buffer_impl.h
        Mercator/DepthShader.cpp
        Mercator/Effector.cpp
        Mercator/FillShader.cpp
        Mercator/Forest.cpp
        Mercator/GrassShader.cpp
        Mercator/HeightMap.cpp
        Mercator/Intersect.cpp
        Mercator/Matrix.cpp
        Mercator/Mercator.cpp
        Mercator/Plant.cpp
        Mercator/Segment.cpp
        Mercator/Shader.cpp
        Mercator/ShaderFactory.cpp
        Mercator/ShaderFactory_impl.h
        Mercator/Surface.cpp
        Mercator/Terrain.cpp
        Mercator/TerrainMod.cpp
        Mercator/TerrainMod_impl.h
        Mercator/ThresholdShader.cpp
        Mercator/TileShader.cpp
        Mercator/iround.h)

set(HEADER_FILES
        Mercator/Area.h
        Mercator/AreaShader.h
        Mercator/BasePoint.h
        Mercator/Buffer.h
        Mercator/DepthShader.h
        Mercator/Effector.h
        Mercator/FillShader.h
        Mercator/Forest.h
        Mercator/GrassShader.h
        Mercator/HeightMap.h
        Mercator/Intersect.h
        Mercator/iround.h
        Mercator/Matrix.h
        Mercator/Mercator.h
        Mercator/Plant.h
        Mercator/RandCache.h
        Mercator/Segment.h
        Mercator/Shader.h
        Mercator/ShaderFactory.h
        Mercator/ShaderFactory_impl.h
        Mercator/Surface.h
        Mercator/Terrain.h
        Mercator/TerrainMod.h
        Mercator/TerrainMod_impl.h
        Mercator/ThresholdShader.h
        Mercator/TileShader.h)

wf_add_library(mercator${SUFFIX} SOURCE_FILES HEADER_FILES)

=== tests/CMakeLists.txt ===
wf_add_test(main.cpp)
wf_add_test(Terraintest.cpp)
wf_add_test(Shadertest.cpp)
wf_add_test(TerrainModtest.cpp)
wf_add_test(Intersecttest.cpp)
wf_add_test(testPhys.cpp)
wf_add_test(Planttest.cpp)
wf_add_test(Foresttest.cpp)
wf_add_test(testQRNG.cpp)
wf_add_test(Areatest.cpp)
wf_add_test(TileShadertest.cpp)
wf_add_test(ShaderFactorytest.cpp)
wf_add_test(testWFMath.cpp)
wf_add_test(Buffertest.cpp)
wf_add_test(Segmenttest.cpp)
wf_add_test(AreaShadertest.cpp)
wf_add_test(BasePointtest.cpp)
wf_add_test(DepthShadertest.cpp)
wf_add_test(FillShadertest.cpp)
wf_add_test(GrassShadertest.cpp)
wf_add_test(ThresholdShadertest.cpp)
wf_add_test(Matrixtest.cpp)
wf_add_test(TerrainaddAreatest.cpp)
wf_add_test(Segmentperf.cpp)
CHECK_INCLUDE_FILE(unistd.h HAS_UNISTD)
if (HAS_UNISTD)
    wf_add_test(timeSeg.cpp util_timer.cpp util_timer.h)
endif()
